<?php

namespace Ulmus;

use Generator;

#class EntityCollection implements \Countable, \ArrayAccess
class EntityCollection extends \ArrayObject {
   #  use Common\ArrayObjectTrait;
    
    public function filters(Callable $callback) : Generator
    {
        $idx = 0;
        
        foreach($this as $key => $item) {
            if ( $callback($item, $key, $idx) ) {
                $idx++;
                
                yield $item;
            }
        }
    }
}